diff --git a/src/settings_type.h b/src/settings_type.h
index 0926db6..c7341cd 100644
--- a/src/settings_type.h
+++ b/src/settings_type.h
@@ -79,6 +79,9 @@ struct GUISettings {
 	int16  autorenew_months;                 ///< how many months from EOL of vehicles should autorenew trigger for new companies?
 	int32  autorenew_money;                  ///< how much money before autorenewing for new companies?
 	byte   news_message_timeout;             ///< how much longer than the news message "age" should we keep the message in the history
+	bool   show_track_reservation;           ///< highlight reserved tracks.
+	uint8  default_signal_type;              ///< the signal type to build by default.
+	uint8  cycle_signal_types;               ///< what signal types to cycle with the build signal tool.
 };
 
 /** Settings related to currency/unit systems. */
@@ -182,6 +185,8 @@ struct NPFSettings {
 	uint32 npf_rail_slope_penalty;           ///< the penalty for sloping upwards
 	uint32 npf_rail_curve_penalty;           ///< the penalty for curves
 	uint32 npf_rail_depot_reverse_penalty;   ///< the penalty for reversing in depots
+	uint32 npf_rail_pbs_cross_penalty;       ///< the penalty for crossing a reserved rail track
+	uint32 npf_rail_pbs_signal_back_penalty; ///< the penalty for passing a pbs signal from the backside
 	uint32 npf_buoy_penalty;                 ///< the penalty for going over (through) a buoy
 	uint32 npf_water_curve_penalty;          ///< the penalty for curves
 	uint32 npf_road_curve_penalty;           ///< the penalty for curves
@@ -215,6 +220,10 @@ struct YAPFSettings {
 	int32  rail_look_ahead_signal_p0;        ///< constant in polynomial penalty function
 	int32  rail_look_ahead_signal_p1;        ///< constant in polynomial penalty function
 	int32  rail_look_ahead_signal_p2;        ///< constant in polynomial penalty function
+	uint32 rail_pbs_cross_penalty;           ///< penalty for crossing a reserved tile
+	uint32 rail_pbs_station_penalty;         ///< penalty for crossing a reserved station tile
+	uint32 rail_pbs_signal_back_penalty;     ///< penalty for passing a pbs signal from the backside
+	uint32 rail_doubleslip_penalty;          ///< penalty for passing a double slip switch
 
 	uint32 rail_longer_platform_penalty;           ///< penalty for longer  station platform than train
 	uint32 rail_longer_platform_per_tile_penalty;  ///< penalty for longer  station platform than train (per tile)
@@ -235,6 +244,10 @@ struct PathfinderSettings {
 	byte   wait_oneway_signal;               ///< waitingtime in days before a oneway signal
 	byte   wait_twoway_signal;               ///< waitingtime in days before a twoway signal
 
+	bool   reserve_paths;                    ///< always reserve paths regardless of signal type.
+	byte   wait_for_pbs_path;                ///< how long to wait for a path reservation.
+	byte   path_backoff_interval;            ///< ticks between checks for a free path.
+
 	OPFSettings  opf;                        ///< pathfinder settings for the old pathfinder
 	NPFSettings  npf;                        ///< pathfinder settings for the new pathfinder
 	YAPFSettings yapf;                       ///< pathfinder settings for the yet another pathfinder
diff --git a/src/signal.cpp b/src/signal.cpp
index 5347964..a45621b 100644
--- a/src/signal.cpp
+++ b/src/signal.cpp
@@ -256,6 +256,7 @@ enum SigFlags {
 	SF_GREEN  = 1 << 3, ///< green exitsignal found
 	SF_GREEN2 = 1 << 4, ///< two or more green exits found
 	SF_FULL   = 1 << 5, ///< some of buffers was full, do not continue
+	SF_PBS    = 1 << 6, ///< pbs signal found
 };
 
 DECLARE_ENUM_AS_BIT_SET(SigFlags)
@@ -322,13 +323,19 @@ static SigFlags ExploreSegment(Owner owner)
 						Trackdir trackdir = (Trackdir)FindFirstBit((tracks * 0x101) & _enterdir_to_trackdirbits[enterdir]);
 						Trackdir reversedir = ReverseTrackdir(trackdir);
 						/* add (tile, reversetrackdir) to 'to-be-updated' set when there is
-						 * ANY signal in REVERSE direction
+						 * ANY conventional signal in REVERSE direction
 						 * (if it is a presignal EXIT and it changes, it will be added to 'to-be-done' set later) */
 						if (HasSignalOnTrackdir(tile, reversedir)) {
-							if (!_tbuset.Add(tile, reversedir)) return flags | SF_FULL;
+							if (IsPbsSignal(sig)) {
+								flags |= SF_PBS;
+							} else if (!_tbuset.Add(tile, reversedir)) {
+								return flags | SF_FULL;
+							}
 						}
+						if (HasSignalOnTrackdir(tile, trackdir) && !IsOnewaySignal(tile, track)) flags |= SF_PBS;
+
 						/* if it is a presignal EXIT in OUR direction and we haven't found 2 green exits yes, do special check */
-						if (!(flags & SF_GREEN2) && (sig & SIGTYPE_EXIT) && HasSignalOnTrackdir(tile, trackdir)) { // found presignal exit
+						if (!(flags & SF_GREEN2) && IsPresignalExit(tile, track) && HasSignalOnTrackdir(tile, trackdir)) { // found presignal exit
 							if (flags & SF_EXIT) flags |= SF_EXIT2; // found two (or more) exits
 							flags |= SF_EXIT; // found at least one exit - allow for compiler optimizations
 							if (GetSignalStateByTrackdir(tile, trackdir) == SIGNAL_STATE_GREEN) { // found green presignal exit
@@ -336,6 +343,7 @@ static SigFlags ExploreSegment(Owner owner)
 								flags |= SF_GREEN;
 							}
 						}
+
 						continue;
 					}
 				}
@@ -433,13 +441,13 @@ static void UpdateSignalsAroundSegment(SigFlags flags)
 					newstate = SIGNAL_STATE_RED;
 				}
 			} else { // entry, at least one exit, no green exit
-				if (sig & SIGTYPE_ENTRY && (flags & SF_EXIT && !(flags & SF_GREEN))) newstate = SIGNAL_STATE_RED;
+				if (IsPresignalEntry(tile, TrackdirToTrack(trackdir)) && flags & SF_EXIT && !(flags & SF_GREEN)) newstate = SIGNAL_STATE_RED;
 			}
 		}
 
 		/* only when the state changes */
 		if (newstate != GetSignalStateByTrackdir(tile, trackdir)) {
-			if (sig & SIGTYPE_EXIT) {
+			if (IsPresignalExit(tile, TrackdirToTrack(trackdir))) {
 				/* for pre-signal exits, add block to the global set */
 				DiagDirection exitdir = TrackdirToExitdir(ReverseTrackdir(trackdir));
 				_globset.Add(tile, exitdir); // do not check for full global set, first update all signals
@@ -532,8 +540,10 @@ static SigSegState UpdateSignalsInBuffer(Owner owner)
 
 		if (first) {
 			first = false;
-			if ((flags & SF_TRAIN) || (flags & SF_EXIT && !(flags & SF_GREEN)) || (flags & SF_FULL)) {
-				/* SIGSEG_FREE is set by default */
+			/* SIGSEG_FREE is set by default */
+			if (flags & SF_PBS) {
+				state = SIGSEG_PBS;
+			} else if (flags & SF_TRAIN || (flags & SF_EXIT && !(flags & SF_GREEN)) || flags & SF_FULL) {
 				state = SIGSEG_FULL;
 			}
 		}
diff --git a/src/signal_func.h b/src/signal_func.h
index 7dcf3fd..7e35168 100644
--- a/src/signal_func.h
+++ b/src/signal_func.h
@@ -45,6 +45,7 @@ static inline byte SignalOnTrack(Track track)
 enum SigSegState {
 	SIGSEG_FREE,    ///< Free and has no pre-signal exits or at least one green exit
 	SIGSEG_FULL,    ///< Occupied by a train
+	SIGSEG_PBS,     ///< Segment is a PBS segment
 };
 
 SigSegState UpdateSignalsOnSegment(TileIndex tile, DiagDirection side, Owner owner);
diff --git a/src/signal_type.h b/src/signal_type.h
index 5dccff6..0bcd107 100644
--- a/src/signal_type.h
+++ b/src/signal_type.h
@@ -14,10 +14,14 @@ enum SignalVariant {
 
 /** Type of signal, i.e. how does the signal behave? */
 enum SignalType {
-	SIGTYPE_NORMAL  = 0, ///< normal signal
-	SIGTYPE_ENTRY   = 1, ///< presignal block entry
-	SIGTYPE_EXIT    = 2, ///< presignal block exit
-	SIGTYPE_COMBO   = 3  ///< presignal inter-block
+	SIGTYPE_NORMAL     = 0, ///< normal signal
+	SIGTYPE_ENTRY      = 1, ///< presignal block entry
+	SIGTYPE_EXIT       = 2, ///< presignal block exit
+	SIGTYPE_COMBO      = 3, ///< presignal inter-block
+	SIGTYPE_PBS        = 4, ///< normal pbs signal
+	SIGTYPE_PBS_ONEWAY = 5, ///< no-entry signal
+	SIGTYPE_LAST       = SIGTYPE_PBS_ONEWAY,
+	SIGTYPE_LAST_NOPBS = SIGTYPE_COMBO
 };
 
 
diff --git a/src/signs_func.h b/src/signs_func.h
index 519a470..5a38ba7 100644
--- a/src/signs_func.h
+++ b/src/signs_func.h
@@ -15,7 +15,6 @@ void PlaceProc_Sign(TileIndex tile);
 
 /* signs_gui.cpp */
 void ShowRenameSignWindow(const Sign *si);
-void HandleClickOnSign(const Sign *si);
 
 void ShowSignList();
 
diff --git a/src/signs_gui.cpp b/src/signs_gui.cpp
index 7a0e9c4..8a9aae2 100644
--- a/src/signs_gui.cpp
+++ b/src/signs_gui.cpp
@@ -8,7 +8,6 @@
 #include "textbuf_gui.h"
 #include "window_gui.h"
 #include "player_gui.h"
-#include "player_func.h"
 #include "signs_base.h"
 #include "signs_func.h"
 #include "debug.h"
@@ -302,15 +301,6 @@ static const WindowDesc _query_sign_edit_desc = {
 	_query_sign_edit_widgets,
 };
 
-void HandleClickOnSign(const Sign *si)
-{
-	if (_ctrl_pressed && si->owner == _local_player) {
-		RenameSign(si->index, "");
-		return;
-	}
-	ShowRenameSignWindow(si);
-}
-
 void ShowRenameSignWindow(const Sign *si)
 {
 	/* Delete all other edit windows and the save window */
diff --git a/src/slope_func.h b/src/slope_func.h
index 99722f6..7bfa5e5 100644
--- a/src/slope_func.h
+++ b/src/slope_func.h
@@ -347,11 +347,13 @@ static inline Corner GetRailFoundationCorner(Foundation f)
  * Returns the foundation needed to flatten a slope.
  * The returned foundation is either FOUNDATION_NONE if the tile was already flat, or FOUNDATION_LEVELED.
  *
+ * @pre      The slope must not be steep.
  * @param s  The current #Slope.
  * @return   The needed #Foundation.
  */
 static inline Foundation FlatteningFoundation(Slope s)
 {
+	assert(!IsSteepSlope(s));
 	return (s == SLOPE_FLAT ? FOUNDATION_NONE : FOUNDATION_LEVELED);
 }
 
diff --git a/src/station_cmd.cpp b/src/station_cmd.cpp
index be9b30f..5ef6498 100644
--- a/src/station_cmd.cpp
+++ b/src/station_cmd.cpp
@@ -43,6 +43,7 @@
 #include "oldpool_func.h"
 #include "animated_tile_func.h"
 #include "elrail_func.h"
+#include <vector>
 
 #include "table/sprites.h"
 #include "table/strings.h"
@@ -928,6 +929,20 @@ CommandCost CmdBuildRailroadStation(TileIndex tile_org, uint32 flags, uint32 p1,
 		if (st == CHECK_STATIONS_ERR) return CMD_ERROR;
 	}
 
+	std::vector<bool> reserved_tiles;
+	if (_settings_game.station.nonuniform_stations) {
+		reserved_tiles.resize(w_org * h_org, false);
+		/* Overbuilding of existing station tiles is possible, check for reserved tiles. */
+		BEGIN_TILE_LOOP(tile_cur, w_org, h_org, tile_org) {
+			if (IsRailwayStationTile(tile_cur)) {
+				bool reserved = GetRailwayStationReservation(tile_cur);
+				/* A reserved tile with the wrong axis can't be overbuilt. */
+				if (reserved && axis != GetRailStationAxis(tile_cur)) return_cmd_error(STR_TRAIN_IS_APPROACHING);
+				reserved_tiles[(h_org - h_cur) * w_org + w_org - w_cur] = reserved;
+			}
+		} END_TILE_LOOP(tile_cur, w_org, h_org, tile_org)
+	}
+
 	/* See if there is a deleted station close to us. */
 	if (st == NULL) st = GetClosestStationFromTile(tile_org);
 
@@ -1018,6 +1033,7 @@ CommandCost CmdBuildRailroadStation(TileIndex tile_org, uint32 flags, uint32 p1,
 
 		numtracks_orig = numtracks;
 
+		TileIndex start_tile = tile_org;
 		do {
 			TileIndex tile = tile_org;
 			int w = plat_len;
@@ -1027,6 +1043,11 @@ CommandCost CmdBuildRailroadStation(TileIndex tile_org, uint32 flags, uint32 p1,
 				SetCustomStationSpecIndex(tile, specindex);
 				SetStationTileRandomBits(tile, GB(Random(), 0, 4));
 				SetStationAnimationFrame(tile, 0);
+				if (_settings_game.station.nonuniform_stations) {
+					/* Restore saved reservation state. */
+					TileIndexDiffC diff = TileIndexToTileIndexDiffC(tile, start_tile);
+					SetRailwayStationReservation(tile, reserved_tiles[diff.y * w_org + diff.x]);
+				}
 
 				if (statspec != NULL) {
 					/* Use a fixed axis for GetPlatformInfo as our platforms / numtracks are always the right way around */
@@ -1148,6 +1169,9 @@ CommandCost CmdRemoveFromRailroadStation(TileIndex tile, uint32 flags, uint32 p1
 			continue;
 		}
 
+		/* Don't remove tile if it is reserved. */
+		if (GetRailwayStationReservation(tile2)) continue;
+
 		/* If there is a vehicle on ground, do not allow to remove (flood) the tile */
 		if (!EnsureNoVehicleOnGround(tile2)) {
 			continue;
@@ -2211,6 +2235,12 @@ static void DrawTile_Station(TileInfo *ti)
 			image += total_offset;
 		}
 		DrawGroundSprite(image, HasBit(image, PALETTE_MODIFIER_COLOR) ? palette : PAL_NONE);
+
+		/* PBS debugging, draw reserved tracks darker */
+		if (_settings_client.gui.show_track_reservation && IsRailwayStation(ti->tile) && GetRailwayStationReservation(ti->tile)) {
+			const RailtypeInfo *rti = GetRailTypeInfo(GetRailType(ti->tile));
+			DrawGroundSprite(GetRailStationAxis(ti->tile) == AXIS_X ? rti->base_sprites.single_y : rti->base_sprites.single_x, PALETTE_CRASH);
+		}
 	}
 
 	if (IsRailwayStation(ti->tile) && HasCatenaryDrawn(GetRailType(ti->tile)) && IsStationTileElectrifiable(ti->tile)) DrawCatenary(ti);
diff --git a/src/station_map.h b/src/station_map.h
index 0ec6797..6d95e96 100644
--- a/src/station_map.h
+++ b/src/station_map.h
@@ -204,6 +204,41 @@ static inline bool IsCompatibleTrainStationTile(TileIndex t1, TileIndex t2)
 		!IsStationTileBlocked(t1);
 }
 
+/**
+ * Get the reservation state of the rail station
+ * @pre IsRailwayStationTile(t)
+ * @param t the station tile
+ * @return reservation state
+ */
+static inline bool GetRailwayStationReservation(TileIndex t)
+{
+	assert(IsRailwayStationTile(t));
+	return HasBit(_m[t].m6, 2);
+}
+
+/**
+ * Set the reservation state of the rail station
+ * @pre IsRailwayStationTile(t)
+ * @param t the station tile
+ * @param b the reservation state
+ */
+static inline void SetRailwayStationReservation(TileIndex t, bool b)
+{
+	assert(IsRailwayStationTile(t));
+	SB(_m[t].m6, 2, 1, (byte)b & 1);
+}
+
+/**
+ * Get the reserved track bits for a waypoint
+ * @pre IsRailwayStationTile(t)
+ * @param t the tile
+ * @return reserved track bits
+ */
+static inline TrackBits GetRailStationReservation(TileIndex t)
+{
+	return GetRailwayStationReservation(t) ? AxisToTrackBits(GetRailStationAxis(t)) : TRACK_BIT_NONE;
+}
+
 
 static inline DiagDirection GetDockDirection(TileIndex t)
 {
@@ -277,6 +312,7 @@ static inline void MakeRailStation(TileIndex t, Owner o, StationID sid, Axis a,
 {
 	MakeStation(t, o, sid, STATION_RAIL, section + a);
 	SetRailType(t, rt);
+	SetRailwayStationReservation(t, false);
 }
 
 static inline void MakeRoadStop(TileIndex t, Owner o, StationID sid, RoadStopType rst, RoadTypes rt, DiagDirection d)
diff --git a/src/table/sprites.h b/src/table/sprites.h
index 7e73cdd..da4d14c 100644
--- a/src/table/sprites.h
+++ b/src/table/sprites.h
@@ -1297,15 +1297,19 @@ enum Sprites {
 	SPR_IMG_RAIL_STATION = 1298,
 	SPR_IMG_RAIL_SIGNALS = 1291,
 
-	SPR_IMG_SIGNAL_ELECTRIC_NORM   = 1287,
-	SPR_IMG_SIGNAL_ELECTRIC_ENTRY  = SPR_SIGNALS_BASE +  12,
-	SPR_IMG_SIGNAL_ELECTRIC_EXIT   = SPR_SIGNALS_BASE +  28,
-	SPR_IMG_SIGNAL_ELECTRIC_COMBO  = SPR_SIGNALS_BASE +  44,
-	SPR_IMG_SIGNAL_SEMAPHORE_NORM  = SPR_SIGNALS_BASE +  60,
-	SPR_IMG_SIGNAL_SEMAPHORE_ENTRY = SPR_SIGNALS_BASE +  76,
-	SPR_IMG_SIGNAL_SEMAPHORE_EXIT  = SPR_SIGNALS_BASE +  92,
-	SPR_IMG_SIGNAL_SEMAPHORE_COMBO = SPR_SIGNALS_BASE + 108,
-	SPR_IMG_SIGNAL_CONVERT         = SPR_OPENTTD_BASE + 135,
+	SPR_IMG_SIGNAL_ELECTRIC_NORM     = 1287,
+	SPR_IMG_SIGNAL_ELECTRIC_ENTRY    = SPR_SIGNALS_BASE +  12,
+	SPR_IMG_SIGNAL_ELECTRIC_EXIT     = SPR_SIGNALS_BASE +  28,
+	SPR_IMG_SIGNAL_ELECTRIC_COMBO    = SPR_SIGNALS_BASE +  44,
+	SPR_IMG_SIGNAL_ELECTRIC_PBS      = SPR_SIGNALS_BASE + 124,
+	SPR_IMG_SIGNAL_ELECTRIC_OBSOWAY  = SPR_SIGNALS_BASE + 140,
+	SPR_IMG_SIGNAL_SEMAPHORE_NORM    = SPR_SIGNALS_BASE +  60,
+	SPR_IMG_SIGNAL_SEMAPHORE_ENTRY   = SPR_SIGNALS_BASE +  76,
+	SPR_IMG_SIGNAL_SEMAPHORE_EXIT    = SPR_SIGNALS_BASE +  92,
+	SPR_IMG_SIGNAL_SEMAPHORE_COMBO   = SPR_SIGNALS_BASE + 108,
+	SPR_IMG_SIGNAL_SEMAPHORE_PBS     = SPR_SIGNALS_BASE + 188,
+	SPR_IMG_SIGNAL_SEMAPHORE_PBSOWAY = SPR_SIGNALS_BASE + 204,
+	SPR_IMG_SIGNAL_CONVERT           = SPR_OPENTTD_BASE + 135,
 
 	SPR_IMG_TUNNEL_RAIL   = 2430,
 	SPR_IMG_TUNNEL_MONO   = 2431,
diff --git a/src/terraform_gui.cpp b/src/terraform_gui.cpp
index a6c4929..c341d6c 100644
--- a/src/terraform_gui.cpp
+++ b/src/terraform_gui.cpp
@@ -135,7 +135,7 @@ bool GUIPlaceProcDragXY(ViewportDragDropSelectionProcess proc, TileIndex start_t
 			DoCommandP(end_tile, start_tile, _ctrl_pressed, CcBuildCanal, CMD_BUILD_CANAL | CMD_MSG(STR_CANT_BUILD_CANALS));
 			break;
 		case DDSP_CREATE_RIVER:
-			DoCommandP(end_tile, start_tile, 2, CcBuildCanal, CMD_BUILD_CANAL | CMD_MSG(STR_CANT_PLACE_RIVERS));
+			DoCommandP(end_tile, start_tile, 2, CcBuildCanal, CMD_BUILD_CANAL | CMD_MSG(STR_CANT_BUILD_CANALS));
 			break;
 		default:
 			return false;
diff --git a/src/toolbar_gui.cpp b/src/toolbar_gui.cpp
index 5cec2aa..f980c69 100644
--- a/src/toolbar_gui.cpp
+++ b/src/toolbar_gui.cpp
@@ -58,22 +58,6 @@ enum ToolbarMode {
 	TB_LOWER
 };
 
-enum ToolbarScenEditorWidgets {
-	TBSE_PAUSE        = 0,
-	TBSE_FASTFORWARD,
-	TBSE_SPACERPANEL  = 4,
-	TBSE_DATEBACKWARD = 6,
-	TBSE_DATEFORWARD,
-	TBSE_ZOOMIN       = 9,
-	TBSE_ZOOMOUT,
-	TBSE_LANDGENERATE,
-	TBSE_TOWNGENERATE,
-	TBSE_INDUSTRYGENERATE,
-	TBSE_BUILDROAD,
-	TBSE_PLANTTREES,
-	TBSE_PLACESIGNS,
-};
-
 static ToolbarMode _toolbar_mode;
 
 static void SelectSignTool()
@@ -583,7 +567,7 @@ static void ToolbarScenDateBackward(Window *w)
 {
 	/* don't allow too fast scrolling */
 	if ((w->flags4 & WF_TIMEOUT_MASK) <= 2 << WF_TIMEOUT_SHL) {
-		w->HandleButtonClick(TBSE_DATEBACKWARD);
+		w->HandleButtonClick(6);
 		w->SetDirty();
 
 		_settings_newgame.game_creation.starting_year = Clamp(_settings_newgame.game_creation.starting_year - 1, MIN_YEAR, MAX_YEAR);
@@ -596,7 +580,7 @@ static void ToolbarScenDateForward(Window *w)
 {
 	/* don't allow too fast scrolling */
 	if ((w->flags4 & WF_TIMEOUT_MASK) <= 2 << WF_TIMEOUT_SHL) {
-		w->HandleButtonClick(TBSE_DATEFORWARD);
+		w->HandleButtonClick(7);
 		w->SetDirty();
 
 		_settings_newgame.game_creation.starting_year = Clamp(_settings_newgame.game_creation.starting_year + 1, MIN_YEAR, MAX_YEAR);
@@ -614,7 +598,7 @@ static void ToolbarScenMapTownDir(Window *w)
 static void ToolbarScenZoomIn(Window *w)
 {
 	if (DoZoomInOutWindow(ZOOM_IN, FindWindowById(WC_MAIN_WINDOW, 0))) {
-		w->HandleButtonClick(TBSE_ZOOMIN);
+		w->HandleButtonClick(9);
 		SndPlayFx(SND_15_BEEP);
 	}
 }
@@ -622,14 +606,14 @@ static void ToolbarScenZoomIn(Window *w)
 static void ToolbarScenZoomOut(Window *w)
 {
 	if (DoZoomInOutWindow(ZOOM_OUT, FindWindowById(WC_MAIN_WINDOW, 0))) {
-		w->HandleButtonClick(TBSE_ZOOMOUT);
+		w->HandleButtonClick(10);
 		SndPlayFx(SND_15_BEEP);
 	}
 }
 
 static void ToolbarScenGenLand(Window *w)
 {
-	w->HandleButtonClick(TBSE_LANDGENERATE);
+	w->HandleButtonClick(11);
 	SndPlayFx(SND_15_BEEP);
 
 	ShowEditorTerraformToolbar();
@@ -638,35 +622,35 @@ static void ToolbarScenGenLand(Window *w)
 
 static void ToolbarScenGenTown(Window *w)
 {
-	w->HandleButtonClick(TBSE_TOWNGENERATE);
+	w->HandleButtonClick(12);
 	SndPlayFx(SND_15_BEEP);
 	ShowBuildTownWindow();
 }
 
 static void ToolbarScenGenIndustry(Window *w)
 {
-	w->HandleButtonClick(TBSE_INDUSTRYGENERATE);
+	w->HandleButtonClick(13);
 	SndPlayFx(SND_15_BEEP);
 	ShowBuildIndustryWindow();
 }
 
 static void ToolbarScenBuildRoad(Window *w)
 {
-	w->HandleButtonClick(TBSE_BUILDROAD);
+	w->HandleButtonClick(14);
 	SndPlayFx(SND_15_BEEP);
 	ShowBuildRoadScenToolbar();
 }
 
 static void ToolbarScenPlantTrees(Window *w)
 {
-	w->HandleButtonClick(TBSE_PLANTTREES);
+	w->HandleButtonClick(15);
 	SndPlayFx(SND_15_BEEP);
 	ShowBuildTreesToolbar();
 }
 
 static void ToolbarScenPlaceSign(Window *w)
 {
-	w->HandleButtonClick(TBSE_PLACESIGNS);
+	w->HandleButtonClick(16);
 	SndPlayFx(SND_15_BEEP);
 	SelectSignTool();
 }
@@ -882,6 +866,12 @@ struct MainToolbarWindow : Window {
 		_place_proc(tile);
 	}
 
+	virtual void OnPlaceObjectAbort()
+	{
+		this->RaiseWidget(25);
+		this->SetDirty();
+	}
+
 	virtual void OnTick()
 	{
 		if (this->IsWidgetLowered(0) != !!_pause_game) {
@@ -999,7 +989,6 @@ static ToolbarButtonProc * const _scen_toolbar_button_procs[] = {
 };
 
 struct ScenarioEditorToolbarWindow : Window {
-public:
 	ScenarioEditorToolbarWindow(const WindowDesc *desc) : Window(desc)
 	{
 		CLRBITS(this->flags4, WF_WHITE_BORDER_MASK);
@@ -1011,8 +1000,8 @@ public:
 
 	virtual void OnPaint()
 	{
-		this->SetWidgetDisabledState(TBSE_DATEBACKWARD, _settings_newgame.game_creation.starting_year <= MIN_YEAR);
-		this->SetWidgetDisabledState(TBSE_DATEFORWARD, _settings_newgame.game_creation.starting_year >= MAX_YEAR);
+		this->SetWidgetDisabledState(6, _settings_newgame.game_creation.starting_year <= MIN_YEAR);
+		this->SetWidgetDisabledState(7, _settings_newgame.game_creation.starting_year >= MAX_YEAR);
 
 		/* Draw brown-red toolbar bg. */
 		GfxFillRect(0, 0, this->width - 1, this->height - 1, 0xB2);
@@ -1021,13 +1010,12 @@ public:
 		this->DrawWidgets();
 
 		SetDParam(0, ConvertYMDToDate(_settings_newgame.game_creation.starting_year, 0, 1));
-		DrawStringCenteredTruncated(this->widget[TBSE_DATEBACKWARD].right, this->widget[TBSE_DATEFORWARD].left, 6, STR_00AF, TC_FROMSTRING);
+		DrawStringCenteredTruncated(this->widget[6].right, this->widget[7].left, 6, STR_00AF, TC_FROMSTRING);
 
 		/* We hide this panel when the toolbar space gets too small */
-		const Widget *panel = &this->widget[TBSE_SPACERPANEL];
-		if (panel->left != panel->right) {
-			DrawStringCenteredTruncated(panel->left + 1, panel->right - 1,  1, STR_0221_OPENTTD, TC_FROMSTRING);
-			DrawStringCenteredTruncated(panel->left + 1, panel->right - 1, 11, STR_0222_SCENARIO_EDITOR, TC_FROMSTRING);
+		if (this->widget[4].left != this->widget[4].right) {
+			DrawStringCenteredTruncated(this->widget[4].left + 1, this->widget[4].right - 1,  1, STR_0221_OPENTTD, TC_FROMSTRING);
+			DrawStringCenteredTruncated(this->widget[4].left + 1, this->widget[4].right - 1, 11, STR_0222_SCENARIO_EDITOR, TC_FROMSTRING);
 		}
 	}
 
@@ -1058,13 +1046,13 @@ public:
 			case WKC_NUM_PLUS:
 			case WKC_EQUALS:
 			case WKC_SHIFT | WKC_EQUALS:
-			case WKC_SHIFT | WKC_F5: ToolbarScenZoomIn(this); break;
+			case WKC_SHIFT | WKC_F5: ToolbarZoomInClick(this); break;
 
 			/* those following are all fall through */
 			case WKC_NUM_MINUS:
 			case WKC_MINUS:
 			case WKC_SHIFT | WKC_MINUS:
-			case WKC_SHIFT | WKC_F6: ToolbarScenZoomOut(this); break;
+			case WKC_SHIFT | WKC_F6: ToolbarZoomOutClick(this); break;
 
 			case 'L': ShowEditorTerraformToolbar(); break;
 			case 'M': ShowSmallMap(); break;
@@ -1079,6 +1067,12 @@ public:
 		_place_proc(tile);
 	}
 
+	virtual void OnPlaceObjectAbort()
+	{
+		this->RaiseWidget(25);
+		this->SetDirty();
+	}
+
 	virtual void OnResize(Point new_size, Point delta)
 	{
 		/* There are 15 buttons plus some spacings if the space allows it.
@@ -1148,20 +1142,20 @@ public:
 
 	virtual void OnTick()
 	{
-		if (this->IsWidgetLowered(TBSE_PAUSE) != !!_pause_game) {
-			this->ToggleWidgetLoweredState(TBSE_PAUSE);
+		if (this->IsWidgetLowered(0) != !!_pause_game) {
+			this->ToggleWidgetLoweredState(0);
 			this->SetDirty();
 		}
 
-		if (this->IsWidgetLowered(TBSE_FASTFORWARD) != !!_fast_forward) {
-			this->ToggleWidgetLoweredState(TBSE_FASTFORWARD);
+		if (this->IsWidgetLowered(1) != !!_fast_forward) {
+			this->ToggleWidgetLoweredState(1);
 			this->SetDirty();
 		}
 	}
 
 	virtual void OnInvalidateData(int data)
 	{
-		if (FindWindowById(WC_MAIN_WINDOW, 0) != NULL) HandleZoomMessage(this, FindWindowById(WC_MAIN_WINDOW, 0)->viewport, TBSE_ZOOMIN, TBSE_ZOOMOUT);
+		if (FindWindowById(WC_MAIN_WINDOW, 0) != NULL) HandleZoomMessage(this, FindWindowById(WC_MAIN_WINDOW, 0)->viewport, 17, 18);
 	}
 };
 
diff --git a/src/track_func.h b/src/track_func.h
index e659121..706de20 100644
--- a/src/track_func.h
+++ b/src/track_func.h
@@ -198,6 +198,21 @@ static inline bool IsValidTrackdir(Trackdir trackdir)
  */
 
 /**
+ * Find the opposite track to a given track.
+ *
+ * TRACK_LOWER -> TRACK_UPPER and vice versa, likewise for left/right.
+ * TRACK_X is mapped to TRACK_Y and reversed.
+ *
+ * @param t the track to convert
+ * @return the opposite track
+ */
+static inline Track TrackToOppositeTrack(Track t)
+{
+	assert(t != INVALID_TRACK);
+	return (Track)(t ^ 1);
+}
+
+/**
  * Maps a trackdir to the reverse trackdir.
  *
  * Returns the reverse trackdir of a Trackdir value. The reverse trackdir
@@ -575,6 +590,19 @@ static inline bool TracksOverlap(TrackBits bits)
 }
 
 /**
+ * Check if a given track is contained within or overlaps some other tracks.
+ *
+ * @param tracks Tracks to be testet against
+ * @param track The track to test
+ * @return true if the track is already in the tracks or overlaps the tracks.
+ */
+static inline bool TrackOverlapsTracks(TrackBits tracks, Track track)
+{
+	if (HasBit(tracks, track)) return true;
+	return TracksOverlap(tracks | TrackToTrackBits(track));
+}
+
+/**
  * Checks whether the trackdir means that we are reversing.
  * @param dir the trackdir to check
  * @return true if it is a reversing road trackdir
diff --git a/src/train.h b/src/train.h
index af7bb94..da6ae35 100644
--- a/src/train.h
+++ b/src/train.h
@@ -273,6 +273,8 @@ int CheckTrainInDepot(const Vehicle *v, bool needs_to_be_stopped);
 int CheckTrainStoppedInDepot(const Vehicle *v);
 void UpdateTrainAcceleration(Vehicle* v);
 
+void FreeTrainTrackReservation(const Vehicle *v, TileIndex origin = INVALID_TILE, Trackdir orig_td = INVALID_TRACKDIR);
+
 /**
  * This class 'wraps' Vehicle; you do not actually instantiate this class.
  * You create a Vehicle using AllocateVehicle, so it is added to the pool
